<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		core
 */

class Block_main_include_module
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=1;
		$info['locked']=false;
		$info['parameters']=array('param','striptitle','onlyifpermissions','leave_page_and_zone','merge_parameters','use_breadcrumbs');
		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @param  array		A map of parameters.
	 * @return tempcode	The result of execution.
	 */
	function run($map)
	{
		$param=array_key_exists('param',$map)?$map['param']:'';
		if ($param=='') return new ocp_tempcode();
		$striptitle=array_key_exists('striptitle',$map)?intval($map['striptitle']):1;
		$onlyifpermissions=array_key_exists('onlyifpermissions',$map)?intval($map['onlyifpermissions']):1;
		$leave_page_and_zone=array_key_exists('leave_page_and_zone',$map)?($map['leave_page_and_zone']=='1'):false;
		$merge_parameters=array_key_exists('merge_parameters',$map)?($map['merge_parameters']=='1'):false;
		$use_breadcrumbs=array_key_exists('use_breadcrumbs',$map)?($map['use_breadcrumbs']=='1'):false;
		list($zone,$attributes,)=page_link_decode($param);
		if (!array_key_exists('page',$attributes)) return new ocp_tempcode();
		if ($zone=='_SEARCH') $zone=get_page_zone($attributes['page'],false);
		elseif ($zone=='_SELF') $zone=get_zone_name();
		if (is_null($zone)) return new ocp_tempcode();
		if (($onlyifpermissions==1) && (!has_actual_page_access(get_member(),$attributes['page'],$zone)))
			return new ocp_tempcode();

		global $SKIP_TITLING;
		if ($striptitle==1)
		{
			$temp=$SKIP_TITLING;
			$SKIP_TITLING=true;
		}
		$temp_get=$_GET;
		if (!$merge_parameters) $_GET=array();
		if ($striptitle==1)
		{
			$_GET['no_frames']='1';
		}
		foreach ($attributes as $key=>$val)
		{
			$_GET[$key]=get_magic_quotes_gpc()?addslashes($val):$val;
		}
		foreach ($temp_get as $key=>$val)
		{
			if ((substr($key,0,5)=='keep_') || ($merge_parameters))
				$_GET[$key]=get_magic_quotes_gpc()?addslashes($val):$val;
		}
		$_GET['in_main_include_module']='1';
		$current_page=$GLOBALS['PAGE_NAME_CACHE'];
		$current_zone=$GLOBALS['ZONE'];
		if (!$leave_page_and_zone)
		{
			$GLOBALS['PAGE_NAME_CACHE']=$attributes['page'];
			if ($zone!=get_zone_name())
			{
				$_zone=$GLOBALS['SITE_DB']->query_select('zones',array('*'),array('zone_name'=>$zone),'',1);
				if (array_key_exists(0,$_zone))
				{
					$_zone[0]['zone_header_text_trans']=get_translated_text($_zone[0]['zone_header_text']);
					$GLOBALS['ZONE']=$_zone[0];
				}
			}
		}
		$temp_displayed_title=$GLOBALS['DISPLAYED_TITLE'];
		$temp_seo_title=$GLOBALS['SEO_TITLE'];
		$temp_current_breadcrumb_extra_segments=$GLOBALS['BREADCRUMB_EXTRA_SEGMENTS'];
		$GLOBALS['BREADCRUMB_EXTRA_SEGMENTS']=new ocp_tempcode(); // Force a new object, so we don't just reassign the tainted reference
		$temp_current_breadcrumbs=$GLOBALS['BREADCRUMBS'];
		$GLOBALS['BREADCRUMBS']=NULL;
		$temp_current_breadcrumb_set_parents=$GLOBALS['BREADCRUMB_SET_PARENTS'];
		$temp_current_breadcrumb_set_self=$GLOBALS['BREADCRUMB_SET_SELF'];
		$GLOBALS['SEO_TITLE']='DO_NOT_REPLACE';
		process_monikers($attributes['page']);
		$out=request_page($attributes['page'],false,$zone,NULL,true);
		if (is_null($out)) $out=new ocp_tempcode();
		$_out=$out->evaluate();
		$GLOBALS['DISPLAYED_TITLE']=$temp_displayed_title;
		$GLOBALS['SEO_TITLE']=$temp_seo_title;
		if (!$use_breadcrumbs)
		{
			$GLOBALS['BREADCRUMB_EXTRA_SEGMENTS']=$temp_current_breadcrumb_extra_segments;
			$GLOBALS['BREADCRUMBS']=$temp_current_breadcrumbs;
			$GLOBALS['BREADCRUMB_SET_PARENTS']=$temp_current_breadcrumb_set_parents;
			$GLOBALS['BREADCRUMB_SET_SELF']=$temp_current_breadcrumb_set_self;
		}
		$GLOBALS['PAGE_NAME_CACHE']=$current_page;
		$GLOBALS['ZONE']=$current_zone;
		$url_from=static_evaluate_tempcode(build_url(array('page'=>$attributes['page']),$zone,NULL,false,false,true));
		$url_to=static_evaluate_tempcode(build_url(array('page'=>get_page_name()),get_zone_name(),NULL,false,false,true));
		$_out=str_replace(str_replace('.htm','',$url_from),str_replace('.htm','',$url_to),$_out);
		$_GET=$temp_get;
		if ($striptitle==1)
		{
			$SKIP_TITLING=$temp;
		}
		$ret=make_string_tempcode($_out);

		return $ret;
	}

}


