<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		calendar
 */

class Hook_members_calendar
{

	/**
	 * Standard modular run function.
	 *
	 * @param  MEMBER		The ID of the member we are getting link hooks for
	 * @return array		List of tuples for results. Each tuple is: type,title,url
	 */
	function run($member_id)
	{
		if (!addon_installed('calendar')) return array();

		if (!has_specific_permission(get_member(),'assume_any_member')) return array();
		if (!has_actual_page_access(get_member(),'calendar',get_module_zone('calendar'))) return array();

		require_lang('calendar');
		return array(array('views',do_lang_tempcode('CALENDAR'),build_url(array('page'=>'calendar','type'=>'misc','member_id'=>$member_id),get_module_zone('calendar'))));
	}

}


