<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		realtime_rain
 */

class Hook_addon_registry_realtime_rain
{
	/**
	 * Get a list of file permissions to set
	 *
	 * @return array			File permissions to set
	 */
	function get_chmod_array()
	{
		return array();
	}

	/**
	 * Get the version of ocPortal this addon is for
	 *
	 * @return float			Version number
	 */
	function get_version()
	{
		return ocp_version_number();
	}

	/**
	 * Get the description of the addon
	 *
	 * @return string			Description of the addon
	 */
	function get_description()
	{
		return 'Real-time/historic display of website activity.';
	}

	/**
	 * Get a mapping of dependency types
	 *
	 * @return array			File permissions to set
	 */
	function get_dependencies()
	{
		return array(
			'requires'=>array('stats'),
			'recommends'=>array(),
			'conflicts_with'=>array()
		);
	}

	/**
	 * Get a list of files that belong to this addon
	 *
	 * @return array			List of files
	 */
	function get_file_list()
	{
		return array(
			'adminzone/pages/modules/admin_realtime_rain.php',
			'sources/realtime_rain.php',
			'data/realtime_rain.php',
			'sources/hooks/systems/snippets/realtime_rain_load.php',
			'sources/hooks/systems/do_next_menus/realtime_rain.php',
			'realtime_rain.css',
			'REALTIME_RAIN_OVERLAY.tpl',
			'REALTIME_RAIN_BUBBLE.tpl',
			'JAVASCRIPT_REALTIME_RAIN.tpl',
			'JAVASCRIPT_BUTTON_REALTIME_RAIN.tpl',
			'lang/EN/realtime_rain.ini',
			'themes/default/images/realtime_rain/index.html',
			'themes/default/images/bigicons/realtime_rain.png',
			'sources/hooks/systems/realtime_rain/.htaccess',
			'sources/hooks/systems/realtime_rain/index.html',
			'sources/hooks/systems/addon_registry/realtime_rain.php',
			'sources/hooks/systems/config_default/bottom_show_realtime_rain_button.php',

			'themes/default/images/footer/realtime_rain.png',
			'themes/default/images/footer/realtime_rain_off.png',

			'themes/default/images/realtime_rain/email-icon.png',
			'themes/default/images/realtime_rain/news-icon.png',
			'themes/default/images/realtime_rain/phone-icon.png',
			'themes/default/images/realtime_rain/searchengine-icon.png',

			'themes/default/images/realtime_rain/news-bg.png',
			'themes/default/images/realtime_rain/news-bot.png',
			'themes/default/images/realtime_rain/news-header.png',
			'themes/default/images/realtime_rain/news-out.png',
			'themes/default/images/realtime_rain/news-top.png',
			'themes/default/images/realtime_rain/next.png',
			'themes/default/images/realtime_rain/pause-but.png',
			'themes/default/images/realtime_rain/pre.png',
			'themes/default/images/realtime_rain/realtime-bubble.png',
			'themes/default/images/realtime_rain/time-line.png',
			'themes/default/images/realtime_rain/timer-bg.png',

			'themes/default/images/realtime_rain/actionlog-avatar.png',
			'themes/default/images/realtime_rain/actionlog-bubble.png',
			'themes/default/images/realtime_rain/banners-avatar.png',
			'themes/default/images/realtime_rain/banners-bubble.png',
			'themes/default/images/realtime_rain/calendar-avatar.png',
			'themes/default/images/realtime_rain/calendar-bubble.png',
			'themes/default/images/realtime_rain/chat-avatar.png',
			'themes/default/images/realtime_rain/chat-bubble.png',
			'themes/default/images/realtime_rain/ecommerce-avatar.png',
			'themes/default/images/realtime_rain/ecommerce-bubble.png',
			'themes/default/images/realtime_rain/join-avatar.png',
			'themes/default/images/realtime_rain/join-bubble.png',
			'themes/default/images/realtime_rain/news-avatar.png',
			'themes/default/images/realtime_rain/news-bubble.png',
			'themes/default/images/realtime_rain/point_charges-avatar.png',
			'themes/default/images/realtime_rain/point_charges-bubble.png',
			'themes/default/images/realtime_rain/point_gifts-avatar.png',
			'themes/default/images/realtime_rain/point_gifts-bubble.png',
			'themes/default/images/realtime_rain/polls-avatar.png',
			'themes/default/images/realtime_rain/polls-bubble.png',
			'themes/default/images/realtime_rain/post-avatar.png',
			'themes/default/images/realtime_rain/post-bubble.png',
			'themes/default/images/realtime_rain/recommend-avatar.png',
			'themes/default/images/realtime_rain/recommend-bubble.png',
			'themes/default/images/realtime_rain/search-avatar.png',
			'themes/default/images/realtime_rain/search-bubble.png',
			'themes/default/images/realtime_rain/security-avatar.png',
			'themes/default/images/realtime_rain/security-bubble.png',
			'themes/default/images/realtime_rain/stats-avatar.png',
			'themes/default/images/realtime_rain/stats-bubble.png',

			'themes/default/images/realtime_rain/sun-effect.png',
			'themes/default/images/realtime_rain/halo-effect.png',
			'themes/default/images/realtime_rain/horns-effect.png',
			'themes/default/images/realtime_rain/shadow-effect.png'
		);
	}

	/**
	 * Get mapping between template names and the method of this class that can render a preview of them
	 *
	 * @return array			The mapping
	 */
	function tpl_previews()
	{
		return array(
			'REALTIME_RAIN_OVERLAY.tpl'=>'administrative__realtime_rain_overlay',
			'REALTIME_RAIN_BUBBLE.tpl'=>'administrative__realtime_rain_bubble'
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__realtime_rain_overlay()
	{
		require_lang('realtime_rain');
		return array(
			lorem_globalise(do_lorem_template('REALTIME_RAIN_OVERLAY', array(
				'MIN_TIME'=>placeholder_id()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__realtime_rain_bubble()
	{
		require_lang('realtime_rain');
		return array(
			lorem_globalise(do_lorem_template('REALTIME_RAIN_BUBBLE', array(
				'TITLE'=>lorem_phrase(),
				'URL'=>placeholder_url(),
				'IMAGE'=>placeholder_image_url(),
				'GROUP_ID'=>placeholder_id(),
				'RELATIVE_TIMESTAMP'=>placeholder_date_raw(),
				'TICKER_TEXT'=>lorem_phrase(),
				'TYPE'=>lorem_word(),
				'IS_POSITIVE'=>true,
				'IS_NEGATIVE'=>false
				// 					''=>(),
			)), NULL, '', true)
		);
	}
}
